<script setup lang="ts">
import { computed, reactive } from 'vue'
import AppCard from './ui/AppCard.vue'
import YearbookExamples from './YearbookExamples.vue'

import profilePicturePlaceholder from '@/assets/example-profile.png'

const props = defineProps<{
  firstname: string
  lastname: string
  profilePictureUrl?: string
  loading?: boolean
  staticBackground?: string
}>()

const state = reactive({
  previewBackground: 'bg-[#3289c6]'
})
</script>

<template>
  <div class="space-y-3">
    <div class="flex flex-col items-center">
      <div class="flex flex-col border-2 border-gray-300 bg-white p-5">
        <div
          class="space-y-8 md:space-y-0 md:space-x-8 rtl:space-x-reverse md:flex md:items-center"
        >
          <div
            :class="`relative overflow-hidden flex items-center justify-center rounded-lg ${staticBackground ?? state.previewBackground}`"
          >
            <img
              :class="`w-[34mm] h-[40mm] ${!!props.profilePictureUrl ? '' : 'opacity-60'}`"
              :src="props.profilePictureUrl ?? profilePicturePlaceholder"
            />
            <div v-if="loading" class="absolute">
              <svg
                class="animate-spin -ml-1 h-16 w-16 text-white"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
              >
                <circle
                  class="opacity-25"
                  cx="12"
                  cy="12"
                  r="10"
                  stroke="currentColor"
                  stroke-width="4"
                ></circle>
                <path
                  class="opacity-75"
                  fill="currentColor"
                  d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
                ></path>
              </svg>
            </div>
          </div>
        </div>
        <div class="mt-2">
          <p id="preview-firstname-text" class="text-[10pt] yearbook-font font-light text-gray-900">
            {{ props.firstname }}
          </p>
          <p id="preview-lastname-text" class="text-[10pt] yearbook-font font-light text-gray-900">
            {{ props.lastname }}
          </p>
        </div>
      </div>

      <p v-if="!staticBackground" class="mt-1 text-sm text-gray-500 dark:text-gray-400">
        {{ $t('preview.previewNote') }}
      </p>
    </div>

    <AppCard
      v-if="!staticBackground"
      class="grow flex flex-col justify-between"
      dense
      :title="$t('preview.bgColorTitle')"
      :description="$t('preview.bgColorDescription')"
    >
      <div>
        <div class="flex justify-evenly">
          <div
            @click="() => (state.previewBackground = 'bg-white')"
            class="bg-white rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
          <div
            @click="() => (state.previewBackground = 'bg-black')"
            class="bg-black rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
          <div
            @click="() => (state.previewBackground = 'bg-gray-300')"
            class="bg-gray-300 rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
          <div
            @click="() => (state.previewBackground = 'bg-[#3289c6]')"
            class="bg-[#3289c6] rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
          <div
            @click="() => (state.previewBackground = 'bg-[#8f3f7f]')"
            class="bg-[#8f3f7f] rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
          <div
            @click="() => (state.previewBackground = 'bg-[#35b440]')"
            class="bg-[#35b440] rounded border-2 border-slate-600 dark:border-slate-200 h-7 w-7 cursor-pointer"
          ></div>
        </div>
      </div>
    </AppCard>

    <YearbookExamples v-if="!staticBackground" dense vertical />
  </div>
</template>

<style scoped>
@font-face {
  font-family: yearbook-font;
  src: url('@/assets/SuisseIntl-Regular.ttf');
}

.yearbook-font {
  font-family: yearbook-font;
}
</style>
